﻿// =================================
// Widget

if (window.widget) {
	widget.onhide = onhide;
	widget.onshow = onshow;
	widget.onload = onload;
}

window.onfocus = focus;
window.onblur = blur;

function focus() {
		setTimeout(focusSearch, 0);
	
}

function blur() {

}


// =================================
// Events Functions

function onshow() {
}

function onhide() {
}

function onload() {
	updateSearchChannel();
	/*
	var element = document.getElementById("searchInput");	
	element.onSearch = doSearch();
	*/	
	
	document.captureEvents(Event.KEYDOWN);
	document.onkeydown = setkey;
	document.onkeyup = onkeyup;
	
	updateSearchChannelList();
	scrollerInit(document.getElementById("myScrollBar"), document.getElementById("myScrollTrack"), document.getElementById("myScrollThumb"));
}

function changeSearchBtnText(url) {
	var searchBtn = document.getElementById("searchBtn");
	if ('~' == url.charAt(0)) {
		searchBtn.value = "Open";
	} else {
		searchBtn.value = "Search";	
	}	
}

function onkeyup(event) {
	if (arrow_scroll_timer) {
		clearInterval(arrow_scroll_timer);
		arrow_scroll_timer = null;
	}
}

function setkey(event){ 
	// keydown events go here
	//logMessage(String.fromCharCode(event.keyCode));
	//iPureSearchScriptObject.logMessage(event.keyCode);
	//iPureSearchScriptObject.logMessage(String.fromCharCode(event.keyCode));
	
	// handle up / down arrow buttoms
	handleUpDownArrow(event.keyCode);
	
	handleShortcut(event);
}	

//var handleUpDownArrowFlag = false;
var arrow_scroll_timer = null;

var arrow_auto_direction;

function handleUpDownArrowAuto() {
	handleUpDownArrow(arrow_auto_direction);
}

function handleUpDownArrow(code) {
	var channelList = document.getElementById("searchChannel");
	var index = channelList.selectedIndex;
	var count = channelList.length;
	
	if (38 == code) {
		index--;
	} else if (40 == code) {
		index++;
	} else {
		return;
	}
	
	/*
	if (false == handleUpDownArrowFlag) {
		handleUpDownArrowFlag = true;
	} else {
		handleUpDownArrowFlag = false;
		return;
	}
	*/
	
	if (index < 0) {
		index = count - 1;
	}
	if (index >= count) {
		index = 0;
	}
	
	channelList.selectedIndex = index;
	changeSearchBtnText(channelList.value);
	
	arrow_auto_direction = code;
	
	if (!arrow_scroll_timer) {
		arrow_scroll_timer = setInterval ('handleUpDownArrowAuto();', 200);
	}
}

var lastSelectedChannel = 0;

function channelReturn() {
	document.getElementById("searchChannel").selectedIndex = lastSelectedChannel;
	changeSearchBtnText(document.getElementById("searchChannel").value);	
}

function handleShortcut(event) {
	var modifier = 0;
	if (true == event.ctrlKey) {
		modifier = 1;
	} else if (true == event.metaKey) {
		modifier = 0;
	} else {
		return;
	}
	
	cmdKey = String.fromCharCode(event.keyCode);

	var channels = iPureSearchScriptObject.arrayOfNames();
	for (var i = 0; i < channels.length; i++) {
		var name = channels[i];
		if (modifier == iPureSearchScriptObject.modifierForSearchEngine(name) &&
				cmdKey.toLowerCase() == iPureSearchScriptObject.commandKeyForSearchEngine(name)) {
			
			var channelList = document.getElementById("searchChannel");
			lastSelectedChannel = channelList.selectedIndex;
			channelList.selectedIndex = i;
			changeSearchBtnText(channelList.value);
			
			if ('~' == channelList.value.charAt(0)) {
				doSearch();
				// jump after 1 second
				setTimeout("channelReturn()",1000); 
				
			} else {
				document.getElementById("searchInput").focus();
			}
			
			// no beep
			event.stopPropagation();
		    event.preventDefault();
		    
			break;				
		}
	}
	
}

function mousemove(event) {
	if (!flipShown)	{
		// fade in the flip widget
		if (animation.timer != null) {
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.timer = setInterval ('animate();', 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}

function mouseexit(event) {
	if (flipShown) {
		// fade in the flip widget
		if (animation.timer != null) {
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.timer = setInterval ('animate();', 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function showbackside(event) {
	var front = document.getElementById('front');
	var back = document.getElementById('behind');
	outputStatus('');

	window.resizeTo(354, 405);
	
	//updateSearchChannelList();
	
	if (window.widget)
		widget.prepareForTransition('ToBack');
	
	front.style.display='none';
	back.style.display='block';
	
	calculateAndShowThumb(document.getElementById("engineListDiv"));
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
	
	document.getElementById('fliprollie').style.display = 'none';

}


function doneMouseDown(event) {
	document.getElementById('done').src = 'Images/done_pressed.png';
}

function doneMouseUp(event) {
	if (window.widget) {
		
	}	
	
	
	document.getElementById('done').src = 'Images/done.png';
	var front = document.getElementById('front');
	var back = document.getElementById('behind');

	if (window.widget)
		widget.prepareForTransition('ToFront');
			
	front.style.display='block';
	back.style.display='none';
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);	

	window.resizeTo(354, 90);

}

// =================================
// Helper Functions

function getLocalizedString (key) {
	try {
		return localizedStrings[key];
	} catch (ex) {}

	return key;
}


function enterflip(event) {
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event) {
	document.getElementById('fliprollie').style.display = 'none';
}

function debug(msg) {
	if (!debug.box) {
		debug.box = document.createElement("div");
		debug.box.setAttribute("style", "background-color: white; " +
										"font-family: monospace; " +
										"border: solid black 3px; " +
										"position: absolute;top:10px;" +
										"padding: 10px;" + 
										"color: black;");

		// broken in Tiger 323, document.body is null
		// document.body.appendChild(debug.box);
		document.appendChild(debug.box);
		
		debug.box.innerHTML = "<div style='text-align:center'>Debug Output</div>";
	}
	
	var p = document.createElement("p");
	p.appendChild(document.createTextNode(msg));
	debug.box.appendChild(p);
}


// =================================
// Flip, Animation Functions

var flipShown = false;

var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, timer:null};

function limit_3 (a, b, c) {
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
    return from + (to - from) * ease;
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time - animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.element.style.opacity = animation.now;
}

// =================================
// interface
function outputStatus(status) {
	document.getElementById('status').innerHTML = status;	
}

function indexOfCurrentChannel() {	
	/*
	var list = document.getElementById('engineList');
	return list.selectedIndex;
	*/
	if (null == currentSelectEngineElem) {
		return -1;
	}
	return currentSelectEngineElem.value;
}

var detailState;

function deleteAction(action) {
	if ("ok" == action) {
		//iPureSearchScriptObject.deleteSearchEngine(document.getElementById('engineList').selectedIndex);
		iPureSearchScriptObject.deleteSearchEngine(indexOfCurrentChannel());
		
		updateSearchChannel();
		updateSearchChannelList();		
	}
	
	var list = document.getElementById('listOption');
	var deleteOption = document.getElementById('deleteOption');

	list.style.display='block';
	calculateAndShowThumb(document.getElementById("engineListDiv"));

	deleteOption.style.display='none';

}

function doDelete() {
	//var selectedName = document.getElementById('engineList').value;
	var selectedName = currentSelectEngineName;
	
	//if (-1 == document.getElementById('engineList').selectedIndex) {
	if (-1 == indexOfCurrentChannel()) {
		outputStatus("Please select an item first.");
		return;
	}

	if (false == iPureSearchScriptObject.isEditableEngine(selectedName)) {
		outputStatus("This item cannot be deleted.");
		return;
	}		

	var string = "Are you sure you want to delete " + 
					selectedName + 
						"? This operation cannot be undone.";
	
	document.getElementById('deleteConformText').innerHTML = string;

	var list = document.getElementById('listOption');
	var deleteOption = document.getElementById('deleteOption');

	outputStatus("");
	list.style.display='none';
	deleteOption.style.display='block';

}

function showDetail(command) {
	var list = document.getElementById('listOption');
	var detail = document.getElementById('detailOption');
	
	detailState = command;
	
	if ("edit" == detailState) {		
		//var selectedName = document.getElementById('engineList').value;
		var selectedName = currentSelectEngineName;
		
		//if (-1 == document.getElementById('engineList').selectedIndex) {
		if (-1 == indexOfCurrentChannel()) {
			outputStatus("Please select an item first.");
			return;		
		}

		if (false == iPureSearchScriptObject.isEditableEngine(selectedName)) {
			outputStatus("This item cannot be altered.");
			return;
		}		
		
		var urlOfSelecedName = iPureSearchScriptObject.urlFromName(selectedName);

		// handle bookmark stuff		
		var safeEngineName = selectedName;
		if ('~' == selectedName.charAt(0)) {
			safeEngineName = selectedName.substring(2);
			document.getElementById('detail_bookmark_checkbox').checked = true;
			
		} else {
			document.getElementById('detail_bookmark_checkbox').checked = false;		
		}
		
		
		document.getElementById('detail_name_text').value = safeEngineName;		
		document.getElementById('detail_url_text').value = urlOfSelecedName;

		document.getElementById('detail_shortcut_key').value = 
			iPureSearchScriptObject.commandKeyForSearchEngine(selectedName);
			
		document.getElementById('detail_shortcut_modifier').selectedIndex = 
			iPureSearchScriptObject.modifierForSearchEngine(selectedName);
			
		document.getElementById('detail_space_text').value = 
			iPureSearchScriptObject.spaceCharForName(selectedName);
	} else {
		// clear the fields
		document.getElementById('detail_bookmark_checkbox').checked = false;

		document.getElementById('detail_name_text').value = "";		
		document.getElementById('detail_url_text').value = "";
		document.getElementById('detail_shortcut_key').value = "";
		document.getElementById('detail_shortcut_modifier').selectedIndex = 0;
	}
	
	list.style.display='none';
	detail.style.display='block';
	document.getElementById("BackBackgroundDiv").src = "backside2.png";
	
	
}

function closeDetail(command) {
	var list = document.getElementById('listOption');
	var detail = document.getElementById('detailOption');
	outputStatus('');

	if ("ok" == command) {
		
		var name = document.getElementById('detail_name_text').value;
		var url = document.getElementById('detail_url_text').value;	

		// sapce
		//var selectedName = document.getElementById('engineList').value;
		var selectedName = currentSelectEngineName;
		var spaceChar = document.getElementById('detail_space_text').value;
		
		iPureSearchScriptObject.setSpaceChar(spaceChar, selectedName);

		
		var bookmark = document.getElementById('detail_bookmark_checkbox').checked;	
		if (true == bookmark) {
			name = '~' + ' ' + name;
		}
		
		// shortcut
		var cmdKey = document.getElementById('detail_shortcut_key').value;
		if (1 == document.getElementById('detail_shortcut_modifier').selectedIndex) {
			cmdKey = "ctrl[#|#]" + cmdKey;
		}
		
		if ("new" == detailState) {
			iPureSearchScriptObject.NewOrEditEngine(-1, name, url, cmdKey);
		} else {
			iPureSearchScriptObject.NewOrEditEngine(indexOfCurrentChannel(), name, url, cmdKey);	
		}		
		
		updateSearchChannel();
		updateSearchChannelList();
	}
	
	list.style.display='block';
	calculateAndShowThumb(document.getElementById("engineListDiv"));

	detail.style.display='none';
	document.getElementById("BackBackgroundDiv").src = "backside.png";

}

function searchChannelChanged() {
	var channel = document.getElementById("searchChannel").value;
	if ('~' == channel.charAt(0)) {
		doSearch();
		setTimeout("channelReturn()",1000); 
		
	} else {
		lastSelectedChannel = document.getElementById("searchChannel").selectedIndex;
	}
	
	document.getElementById("searchInput").focus();
}

// =================================
// plugin

function shortcutStringForName(name) {
	var cmdKey = iPureSearchScriptObject.commandKeyForSearchEngine(name);
	var modifier = iPureSearchScriptObject.modifierForSearchEngine(name);
	
	if ("" == cmdKey) {
		return name;
	}
	
	var string = name + " (";
	if (0 == modifier) {
		string += "⌘";
	} else {
		string += "^";	
	}
	
	string += cmdKey.toUpperCase();
	string += ")";
	return string;
}

/*
function nameForIndex() {
	var list = document.getElementById('engineList');
	var index = list.selectedIndex;
	if (-1 == index) {
		return "";
	}
	//return iPureSearchScriptObject.nameForIndex(index);
	list.value;
}
*/

function updateSearchChannel() {
	if (!iPureSearchScriptObject)
		return;

    var select = document.getElementById("searchChannel");
    while (select.length > 0) {
        select.remove(0);
    }
	
	var channels = iPureSearchScriptObject.arrayOfNames();
	
	var count = channels.length;
	
	for (var i = 0; i < count; i++) {
		var opt;
		opt = document.createElement("option");
		opt.value = channels[i];
		var nameWithShortcut = shortcutStringForName(channels[i]);
		opt.appendChild(document.createTextNode(nameWithShortcut));
		select.appendChild(opt);	
	}
	
}

var currentSelectEngineName = "";
var currentSelectEngineElem = null;

function selectEngine(element) {
	if (currentSelectEngineElem == element) {
		return;
	}
	
	if (currentSelectEngineElem) {
		currentSelectEngineElem.className = "";
	}
	
	currentSelectEngineElem = element;
	currentSelectEngineName = currentSelectEngineElem.innerText
		
	currentSelectEngineElem.className = 'selected';
	 	   
}


function updateSearchChannelList() {
	
	if (!iPureSearchScriptObject)
		return;

	currentSelectEngineName = "";
	currentSelectEngineElem = null;

    var list = document.getElementById("engineULList");
    while (list.childNodes.length > 0) {
        list.removeChild(list.childNodes[0]);
    }
    	
	var channels = iPureSearchScriptObject.arrayOfNames();
	
	var count = channels.length;
	
	for (var i = 0; i < count; i++) {
		/*
		var opt;
		opt = document.createElement("option");
		opt.value = channels[i];
		opt.appendChild(document.createTextNode(channels[i]));
		select.appendChild(opt);
		*/
		// use list instead
		
		var a = document.createElement('a');
		var li = document.createElement('li');

		a.href = '#';
		a.onclick = function() {selectEngine(this);}
		/*
		a.onmouseover = function() {this.style.backgroundColor = "#369";}
		a.onmouseout = function() {if (this.innerText == currentSelectEngineName) {this.style.backgroundColor = "#07115e";} else {this.style.backgroundColor = "#036";} }
		*/
		
		a.innerText = channels[i];
		a.value = i;
		
		if (false == iPureSearchScriptObject.isEditableEngine(channels[i])) {
			a.style.fontWeight = "bold";
		}
		
	
		li.appendChild(a);
		list.appendChild(li);	
	}
	
	//calculateAndShowThumb(document.getElementById("engineListDiv"));
	
}

function focusSearch() {
	var searchField = document.getElementById("searchInput");
	searchField.focus();
	searchField.select();
}

function doSearch() {
	var searchField = document.getElementById("searchInput");
	
	if (iPureSearchScriptObject) {
		value = searchField.value;
		if ("" == value) {
			var channel = document.getElementById("searchChannel").value;
			if ('~' != channel.charAt(0)) {			
				return;
			}
		}
		
	    var select = document.getElementById("searchChannel");
	    iPureSearchScriptObject.logMessage(select.value);
	    var url = iPureSearchScriptObject.urlForSearch(value, select.value);
		widget.openURL(url);
		//searchField.focus();
		setTimeout(focusSearch, 0);

	}		
}
